/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.jsf.conventions.service.impl;

import com.jsf.conventions.dao.HibernateDao;
import com.jsf.conventions.qualifier.CustomHibernateDao;
import com.jsf.conventions.qualifier.CustomService;
import com.jsf.conventions.service.BaseService;
import java.io.Serializable;
import java.lang.reflect.ParameterizedType;
import javax.enterprise.inject.spi.InjectionPoint;
import javax.inject.Inject;
import javax.inject.Named;

/**
 * Non EJB dependent service
 * to it work properly you should provide an EntityManager
 * via producer method like the example in the link
 * {@link https://github.com/rmpestano/conventions-issuetracker/blob/master/src/br/com/triadworks/issuetracker/producer/EntityManagerProducer.java}
 * @author rmpestano
 */
@Named
@CustomService
public class CustomHibernateService<T,K extends Serializable> extends BaseCustomServiceImpl<T, K> implements BaseService<T, K> {

    
    public CustomHibernateService() {
    }

    @Inject
    public void StandaloneHibernateService(@CustomHibernateDao HibernateDao<T, K> hibernateDao,InjectionPoint ip) {
          if(ip.getAnnotated() != null && ip.getAnnotated().isAnnotationPresent(CustomService.class)){//when injecting BaseService direct in a bean you will need to pass the PersistentClass via annotation
            Class persistentClass = ip.getAnnotated().getAnnotation(CustomService.class).entity();
            if(!persistentClass.isPrimitive()){
                hibernateDao.setPersistentClass(persistentClass);
            }
        }
        else{//when you inherit this class (usually when defining your own entity service) you dont need to use @PersistentClass cause it will be resolved via reflection
            hibernateDao.setPersistentClass((Class<T>) ((ParameterizedType) getClass().getGenericSuperclass()).getActualTypeArguments()[0]);
        }
        super.setDao(hibernateDao);
       
    }
    

}
